searchNodes=[{"ref":"Defconst.html","title":"Defconst","type":"module","doc":"Define constants and enum with use in guards Define a contant defmodule ConstType do use Defconst defconst :one, 1 defconst :two, 2 end Define an enum with default values defmodule EnumType1 do use Defconst defenum [ :zero, :one, :two ] end Define an enum with explicit values defmodule EnumType2 do use Defconst defenum [ {:one, 1}, {:nine, 9}, :ten ] end"},{"ref":"Defconst.html#defconst/2","title":"Defconst.defconst/2","type":"macro","doc":"Define constant Examples: iex&gt; defmodule ConstType do ...&gt; use Defconst ...&gt; ...&gt; defconst :one, 1 ...&gt; defconst :two, 2 ...&gt; end iex&gt; defmodule ConstUse do ...&gt; require ConstType ...&gt; ...&gt; def const_value(x) do ...&gt; case x do ...&gt; ConstType.one -&gt; &quot;one&quot; ...&gt; ConstType.two -&gt; &quot;two&quot; ...&gt; _ -&gt; &quot;unknown&quot; ...&gt; end ...&gt; end ...&gt; ...&gt; def const_guard(x) when x == ConstType.two do ...&gt; &quot;two&quot; ...&gt; end ...&gt; end iex&gt; ConstType.constants [{:one, 1}, {:two, 2}] iex&gt; ConstUse.const_value(1) &quot;one&quot; iex&gt; ConstUse.const_guard(2) &quot;two&quot;"},{"ref":"Defconst.html#defenum/2","title":"Defconst.defenum/2","type":"macro","doc":"Defines an enum with specified constant names and optional values Examples: iex&gt; defmodule EnumType1 do ...&gt; use Defconst ...&gt; ...&gt; defenum [ ...&gt; :zero, ...&gt; :one, ...&gt; :two ...&gt; ] ...&gt; end iex&gt; defmodule EnumUse1 do ...&gt; require EnumType1 ...&gt; ...&gt; def enum_value(x) do ...&gt; case x do ...&gt; EnumType1.zero -&gt; &quot;zero&quot; ...&gt; EnumType1.one -&gt; &quot;one&quot; ...&gt; EnumType1.two -&gt; &quot;two&quot; ...&gt; _ -&gt; &quot;unknown&quot; ...&gt; end ...&gt; end ...&gt; ...&gt; def enum_guard(x) when x == EnumType1.two do ...&gt; &quot;two&quot; ...&gt; end ...&gt; end iex&gt; EnumType1.constants [zero: 0, one: 1, two: 2] iex&gt; EnumUse1.enum_value(1) &quot;one&quot; iex&gt; EnumUse1.enum_guard(2) &quot;two&quot; iex&gt; defmodule EnumType2 do ...&gt; use Defconst ...&gt; ...&gt; defenum [ ...&gt; {:zero, &quot;zero&quot;}, ...&gt; {:one, 1}, ...&gt; {:nine, 9}, ...&gt; :ten ...&gt; ] ...&gt; end iex&gt; defmodule EnumUse2 do ...&gt; require EnumType2 ...&gt; ...&gt; def enum_value(x) do ...&gt; case x do ...&gt; EnumType2.zero -&gt; &quot;zero&quot; ...&gt; EnumType2.one -&gt; &quot;one&quot; ...&gt; EnumType2.nine -&gt; &quot;nine&quot; ...&gt; EnumType2.ten -&gt; &quot;ten&quot; ...&gt; _ -&gt; &quot;unknown&quot; ...&gt; end ...&gt; end ...&gt; ...&gt; def enum_guard(x) when x == EnumType2.ten do ...&gt; &quot;ten&quot; ...&gt; end ...&gt; end iex&gt; EnumType2.constants [zero: &quot;zero&quot;, one: 1, nine: 9, ten: 10] iex&gt; EnumUse2.enum_value(1) &quot;one&quot; iex&gt; EnumUse2.enum_guard(10) &quot;ten&quot;"},{"ref":"Defconst.Enum.DefaultGenerator.html","title":"Defconst.Enum.DefaultGenerator","type":"module","doc":"Default implementation of enum generator"},{"ref":"Defconst.Enum.DefaultGenerator.html#next_value/2","title":"Defconst.Enum.DefaultGenerator.next_value/2","type":"function","doc":"Next value when previous value is binary Examples: iex&gt; Defconst.Enum.DefaultGenerator.next_value(:bye, &quot;hello&quot;) &quot;hello1&quot;"},{"ref":"Defconst.Enum.Generator.html","title":"Defconst.Enum.Generator","type":"behaviour","doc":"Callbacks definition for generating enum values"},{"ref":"Defconst.Enum.Generator.html#c:next_value/2","title":"Defconst.Enum.Generator.next_value/2","type":"callback","doc":""},{"ref":"readme.html","title":"Defconst","type":"extras","doc":"Defconst This package provides defconst macro for defining a single constant and defenum macro for defining a list of enumerated constant values. The defined constants and enumerated constants are referencable in any expression as well as in guards statements."},{"ref":"readme.html#installation","title":"Defconst - Installation","type":"extras","doc":"Defconst can be installed by adding defconst to your list of dependencies in mix.exs: def deps do [ {:defconst, &quot;~&gt; 0.2.2&quot;} ] end"},{"ref":"readme.html#usage","title":"Defconst - Usage","type":"extras","doc":"defconst Define ConstType1 module with constants defmodule ConstType1 do use Defconst defconst :one, 1 defconst :two, 2 end Use ConstType1 module defmodule ConstUse1 do require ConstType1 def const_value(x) do case x do ConstType1.one -&gt; &quot;one&quot; ConstType1.two -&gt; &quot;two&quot; end end def const_guard(x) when x == ConstType1.two do &quot;two&quot; end end defenum Define EnumType1 module with default values defmodule EnumType1 do use Defconst defenum [ :zero, :one, :two ] end Use EnumType1 module defmodule EnumUse1 do require EnumType1 def enum_value(x) do case x do EnumType1.zero -&gt; &quot;zero&quot; EnumType1.one -&gt; &quot;one&quot; EnumType1.two -&gt; &quot;two&quot; _ -&gt; &quot;unknown&quot; end end def enum_guard(x) when x == EnumType1.two do &quot;two&quot; end end Define EnumType2 with specific values defmodule EnumType2 do use Defconst defenum [ {:one, 1}, {:nine, 9}, {:ten, &quot;ten&quot;} ] end Define EnumType3 using EnumGenerator3 defmodule EnumGenerator3 do @behaviour Defconst.Enum.Generator def next_value(_constant_name, previous_value) do previous_value &lt;&gt; previous_value end end defmodule TestEnumType3 do use Defconst defenum [ {:one, &quot;one&quot;}, {:nine, &quot;nine&quot;}, :ten ], EnumGenerator3 end"}]